/*

Copyright _ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.

*/
var updateTimer;
var timeoutUpdate;
var hidden = false;

if (window.widget) {
	widget.onshow = onshow;
	widget.onhide = onhide;
}

function onshow() {
	hidden = false;
	var front = document.getElementById("front");
	if (front.style.display == "block") {
		if (!callInProgress(req)) {
			query("getDownloads", g_dm_oID, processDownloads);
		}
	}
}

function onhide() {
	hidden = true;
	if (updateTimer) {
		debug("updateTimer unset");
		updateTimer = clearTimeout(updateTimer);
	}
	if (timeoutUpdate) {
		timeoutUpdate = clearTimeout(timeoutUpdate);
	}
}

function autoUpd() {
	if(!callInProgress(req)) {
		progInd.start();
		query("getDownloads", g_dm_oID, processDownloads);
		debug("updating again in " + updateSec + " seconds");
		updateTimer = setTimeout("autoUpd();", updateSec);
	}
}

function getUpdateSec() {
	updateSec = parseInt(widget.preferenceForKey("updateSec"))*1000;
	if (updateSec == "NaN") {
		updateSec = 5000;
	}
}

function setUpdate(l) {
	getUpdateSec();
	if (updateSec == 0) {
		if (updateTimer) {
			updateTimer = clearTimeout(updateTimer);
		}
		updateTimer = setTimeout("autoUpd();", updateSec);
	} else {
		if (l) { scan() };
		updateTimer = setTimeout("autoUpd();", updateSec);
	}
}

/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

//my array of prefs
thePrefs = new Array('hostname','port','updateSec', 'uselogin', 'username', 'password');


function showPrefs() {
	// reset any errors
	error = false;
	
	// cancel any pending requests
	/*if (callInProgress(req)) {
		req.abort();
		req = null;
	}*/
	
	if (timeoutUpdate)
		timeoutUpdate = clearTimeout(timeoutUpdate);

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	//set the fields to the prefs if they exist
	if (window.widget) {
		for (i=0; i<thePrefs.length; i++) {
			if (widget.preferenceForKey(thePrefs[i]) != "" && widget.preferenceForKey(thePrefs[i]) != "undefined") {
				document.getElementById(thePrefs[i]).value = widget.preferenceForKey(thePrefs[i]);
			}
		}

	}


	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	window.resizeTo(401,327);
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
	
	document.getElementById('hostname').focus();
}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs() {
	
	// erase whatever info is on the front

	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	//write the prefs
	if (window.widget) {
		for (i = 0; i < thePrefs.length; i++) {
			widget.setPreferenceForKey(document.getElementById(thePrefs[i]).value, thePrefs[i]);
		}
	}


	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
		
	if (window.widget) {
		var timeoutValue = widget.preferenceForKey("updateSec") * 1000;
		setTimeout('setStatus(\"<h2>Retrieving torrents...</h2>")', 0);
		progInd.start();
		setTimeout('widget.performTransition();', 0);		// and flip the widget back to the front
		timeoutUpdate = window.setTimeout('timeoutError();', timeoutValue);
	}
	
	//reload the file
	start = false;
	clearDetails();
	setup();

}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		// /
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}




// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}


function enterarrow(event)
{
	document.getElementById('arrowrollie').style.display = 'block';
}

function exitarrow(event)
{
	document.getElementById('arrowrollie').style.display = 'none';
}


function fade(obj, oFadeto, duration) {
	if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
	{
		clearInterval (animation.timer);
		animation.timer  = null;
	}
	
	var starttime = (new Date).getTime() - 13; 		// set it back one frame
	
	animation.duration = duration;
	animation.starttime = starttime;
	animation.firstElement = obj;
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = oFadeto;
	animate();

}


/******** Progress Indicator *********/

function ProgressIndicator(element, imageBaseURL) {
    this.count = 0;
    this.timer = null;
    this.element = element;
    this.element.style.display = "none";
    this.imageBaseURL = imageBaseURL;
}

ProgressIndicator.prototype = {
    start : function () {
		debug("spinner started");
		document.getElementById('arrow').style.display = "none";
		document.getElementById('arrowrollie').style.display = "none";		
        this.element.style.display = "block";        
        if (this.timer) clearInterval(this.timer);
        this.tick();
        var localThis = this;
        this.timer = setInterval (function() { localThis.tick() }, 60);
    },

    stop : function () {
		debug("spinner stopped");
 		document.getElementById('arrow').style.display = "block";
        clearInterval(this.timer);
        this.element.style.display = "none";
    },

    tick : function () {
        var imageURL = this.imageBaseURL + (this.count + 1) + ".png";
        this.element.src = imageURL;
        this.count = (this.count + 1) % 12;
    }
}



